vector = {}
function vector.add(v1,v2)
	return vector:new(v1.x+v2.x,v1.y+v2.y)
end

function vector.sub(v1,v2)
	return vector:new(v1.x-v2.x,v1.y-v2.y)
end

function vector.str(v1)
	return "{"..v1.x..","..v1.y.."}"
end

function vector:length()
	return math.sqrt(self.x*self.x + self.y * self.y)
end

function vector:length_square()
	return self.x*self.x + self.y *self.y
end

function vector:new(x,y)
	return setmetatable({x=x,y=y},{__index = vector,__add = vector.add,__sub = vector.sub,__tostring=vector.str})
end
