dofile("sys/lua/speed_detection/vector.lua")
addhook("ms100","ms100_hook")
addhook("join","join_hook")

function array(v,n)
	a = {}
	for i=1,n do a[i] = v end
	return a
end

toleration = 1.5
teleport_distance = 150

pos = array({},32)

function join_hook(id)
	pos[id] = {}
end

function ms100_hook()
	living_players = player(0,"tableliving")	
	for i = 1, #living_players do
		local id = living_players[i]
		local x,y = player(id,"x"),player(id,"y")
		local v = vector:new(x,y)
		table.insert(pos[id],v)
		if #pos[id] >= 10 then
			table.remove(pos[id],1)
		end
		
		local sum = 0
		local count = 0
		for i=2,#pos[id] do
			if(pos[id][i] ~= nil and pos[id][i-1] ~= nil) then
				
				local dist = (pos[id][i] - pos[id][i-1]):length()				
				if dist <= teleport_distance then -- else, player teleported by map trigger or
					sum = sum + (pos[id][i] - pos[id][i-1]):length()
					count = count + 1
				end
			end
		end
		local average
		if count >= 8 then
			average = sum/ count
		else
			average = 0
		end
		
		local speed = 16 + player(id,"speedmod")*0.6
		if average >= toleration * speed then
			parse("kick "..id)
			pos[id] = {} -- I hope garbage collector kicks in here
		end			
	end
end